
(function($) {
    $.fn.changeElementType = function(newType) {
        var attrs = {};

        $.each(this[0].attributes, function(idx, attr) {
            attrs[attr.nodeName] = attr.nodeValue;
        });

        this.replaceWith(function() {
            return $("<" + newType + "/>", attrs).append($(this).contents());
        });
    };
})(jQuery);

Figures = Figures.extend({

    bcPlayerData: { 'accountId': '1500315202001', 'playerId': 'B1AhVYg4l' },   
    
    process_media: function() {

        var context = this; // safe off 'this'
        
        // Process each video
        $("[data-mmtype='mov']").each(function() {
            var $this = $(this);
            var $parent = $this.parent("[data-type='figure']");
            var video_mmsrc = $this.attr("data-mmsrc");
            var video_id = $parent.attr("data-figure-id");

            $('#'+video_id).css('float','none').css('width','100%').css('margin-left','0');

            // Replace the current figure HTML with the new HTML5 video HTML
            playerHTML = '<div id=\"outer_outer_outer_video\"><div id=\"outer_outer_video\"><div id=\"outer_video\"><video id=\"' + video_id + '\" data-video-id=\"' + video_mmsrc + '\"  data-account=\"' + context.bcPlayerData.accountId + '\" data-player=\"' + context.bcPlayerData.playerId + '\" data-embed=\"default\" class=\"video-js\" controls></video></div></div></div>';
            $parent.before(playerHTML);
            $parent.remove();

            // instantiate the player
            bc(document.getElementById(video_id));

            // create player instance and set up cuepoints
            videojs(video_id).ready(function() {
                // brb: For some reason some of these videos think they 
                // have a tiny layout, so let's remove the class that 
                // signals this, just in case. Tiny layout keeps most
                // of the video controls from showing.
                $('.video-js').removeClass('vjs-layout-tiny');
                // All of these videos have a left margin hard coded in the 
                // manuscript-specific css file. Undo that.
                $('#'+video_id).css('margin-left', '0');
            }); //end ready
        });
    }

});

var Activity_local = Activity_manuscript_type.extend({

    restore_saved_answers: function() {
        // skip page queries (questions[0])
        for (var i = 1; i < this.questions.length; ++i) {
            var question = this.questions[i];

            // prepare for question_report_text questions
            var query_responses;
            if (question.md_set("question_report_text")) {
                query_responses = "" + Get_ARGA_QuestionData(this.get_question_number(question))
                query_responses = query_responses.split(this.query_responses_separator);
            }

            var restored_all_answers = true;			
            var all_answers_correct = true;
            for (var j = 0; j < question.queries.length; ++j) {
                var query = question.queries[j];
                
                var saved_answer, saved_grade;
                
                // get saved answer and grade out of the questionData for question_report_text questions
                if (question.md_set("question_report_text")) {
                    if (query_responses[j] != null) {
                        var arr = query_responses[j].split(this.query_responses_grade_separator);
                        saved_answer = arr[0];
                        saved_grade = arr[1];
                    } else {
                        saved_grade = saved_answer = "";
                    }
                    
                // or out of learnerResponse / questionData for single-query questions
                } else {
                    var ARGA_question_number = this.get_query_number(question, j);
                    saved_answer = Get_ARGA_LearnerResponse(ARGA_question_number);
                    // we stored the original grade in questionData
                    saved_grade = Get_ARGA_QuestionData(ARGA_question_number)
                }
                
                // if we found a grade...
                if (saved_grade !== "" && saved_grade >= 0) {
                    // restore the answer
                    query.restoreAnswerFromARGA(saved_answer);
                    query.setGrade(saved_grade);
                    
                    // then re-render the query in review mode
                    query.jq.html(query.getHTML("review"));
                    
                    if (query.isCorrect() == false) {
                        all_answers_correct = false;
                    }
                    
                } else {
                    restored_all_answers = false;
                }
            }
            
            if (restored_all_answers) {
                // update the submit div for the question
                this.update_question_action_div(i);

                // Show appropriate feedback. If the question responses were submitted, 
                // the student must have finished the question, so we don't have to worry
                // about hints.
                this.show_question_feedback(question, all_answers_correct, false);
                
                // if the item is in a sequence, show the next question
                this.show_next_question(question);
                
                // NEED TO CHECK TO MAKE SURE THIS IS WORKING PROPERLY
                // If the question is in a sequence and the sequence is complete, call show_closing_material
                var qs = question.question_sequence;
                if (qs != null && qs.sequence_complete == "partial") {
                    this.show_closing_material(qs.index);
                }

                // update section status
                player.update_section_status();

                // brb: remove submit button for question
                $('#question_submit_button_'+i).remove();
            }
        }
    },

    submit_question: function(question_index) {
        // make sure they have entered text
        if (typeof question_index == "object") {
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }

        var query = player.activity.questions[question_index].queries[0];
        var answer = $('#query_answer_'+query.query_index).val().trim();

        $('#submit_error_'+query.query_index).remove();

        if (!(/\S/.test(answer))) {
            $('#query_answer_'+query.query_index).after('<div class="submit_error" id="submit_error_' + query.query_index + '">You must answer the question before submitting.</div>');
            player.aria_speech("Submission error, you must answer the question before submitting.");
            return;
        }

        this._super(question_index);

        // if question was answered then send feedback to screen reader
        if (player.activity.questions[question_index].queries[0].grade == 100) {

            var completed = "";

            // if this was the last question to be answered then also send 
            // end of activity message
            if (player.all_questions_answered()) {
                completed = " You have completed this activity. Your provisional score has been sent to the grade book, but your instructor may change your grade after reviewing your answers.";
                player.activity_complete();
            }

            player.aria_speech("Question " + question_index + " feedback: Your answer has been provisionally accepted. You'll get full credit for now, but your instructor may update your grade later after evaluating it." + completed);
        }

    },

    update_question_action_div: function(question_index) {
        var question = this.questions[question_index];

        // calculate points_awarded and points_possible
        var points_awarded = 0;
        var points_possible = 0;
        var points_provisional = false;
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];
            points_awarded += query.getPointsAwarded();
            points_possible += query.getPointsPossible();
            if (query.pointsAreProvisional() == true) {
                points_provisional = true;
            }
        }

        // round to at most two decimal places
        points_awarded = Math.round(points_awarded * 100) / 100;
        points_possible = Math.round(points_possible * 100) / 100;
        
        // hide submit button (and any other similar buttons that might be added by subtypes), but show points earned
        var jq = $("#question_action_div_" + question.index);
        //jq.find(".question_submit_button").remove();
        jq.find(".question_submit_button").attr('aria-disabled','true').unbind('click');
        var points_html = "<div class='points_awarded_div'>Points awarded: " + points_awarded + " out of " + points_possible;

        if (points_provisional) {
            points_html += " (<a href='javascript:player.activity.explain_provisional()'>provisional</a>)";
        }
        points_html += "</div>";

        var jq = $("#question_action_div_" + question.index);
        jq.find(".points_awarded_div").remove();
        /*
        if (jq.find(".question_feedback").length > 0) {
            jq.find(".question_feedback").after(points_html);
        } else {
            jq.prepend(points_html);
        }
        */
    },

    question_submit_button: function(q) {
        // define question_submit_button_label as a variable so it can be overridden
        var button_html = "<input class='standard_button question_submit_button' type='button' id='question_submit_button_" + q.index + "' value='" + player.activity.question_submit_button_label + "' aria-label='Question " + q.index + " submit'/>";

        return button_html;
    },



});


xBookUtils.bookID = "video_success_accessible";
xBookUtils.discipline = {
    dev: 6700,
    qa: 6700,
    pr: 6700,
    www: 6700
}

var Player_subtype = Player_manuscript_type.extend({

    ACTIVITY_COMPLETED: false,
    DUE_DATE_HAS_PASSED: false,

    all_questions_answered: function() {
        var questions = player.activity.questions;
        var q_len = questions.length;

        for (var i=1; i<q_len; i++) {
            if (questions[i].queries[0].grade !== 100) {
                return false;
            }
        }

        return true;
    },

    // To be called after the last question has been answered. Will display a 
    // completion message at the bottom of the page.
    activity_complete: function() {
        $('#manuscript').append('<div id="activity_completed"><p>You have completed this activity. Your provisional score has been sent to the grade book, but your instructor may change your grade after reviewing your answers.</p></div>');
    },


    initialize_sections: function() {
	
	// Do not delete this
	this._super();
	
        // Anything that needs to be done before the page displays 
	// should be done here.
	
        // This is needed to help PX figure out the initial height
	// of the content frame so the iframe heights can be set correctly
	$('[data-type="rawhtml"]').each(function() {
	    var $this = $(this);
	    $this.wrap("<div style='height: 475px'>");
	});


	
    }, // end initialize_sections
    
    
    
    initialize: function(id) {

	// Do not delete this
	this._super(id);
    
    this.activity = new Activity_local();

	this.xrefs = new XRefs_manuscript_subtype();
	this.glossary = new Glossary_manuscript_subtype({terms: false});
        this.figures = new Figures_manuscript_subtype();

    },


    initialize2: function() {
        this._super();
	
        // anything that you want to do after *everything* has been set up
        // should be done here.

        // brb: Need to set allowfullscreen to true on parent iframe so videos
        // can go to full screen
        $('#document-body-iframe', window.parent.document).attr('allowfullscreen', 'true').attr('mozallowfullscreen', 'true').attr('webkitallowfullscreen', 'true');

            // fix h1 text
            var $h2 = $('h2.section-title');
            var h2_text = $h2.find('[data-type="title"]').html();
            $h2.html(h2_text);
            $h2.css('display', 'block');
            $h2.attr('tabindex','-1');
            $h2.attr('id','h1_header');
            $h2.changeElementType('h1');

            if (player.ARGA_running) {
                // brb: determine if activity has been completed (all ARGA answered)
                try {
                  var dejs_arr = ARGA_API.dejs_data;
                  for (var i=0; i<dejs_arr.length; i++) {
                    if (dejs_arr[i].name === "cmi.completion_status") {
                      this.ACTIVITY_COMPLETED = (ARGA_API.dejs_data[i].value == "completed");
                      break;
                    }
                  }
                }
                catch(err) {
                  safe_log("initialize2: Can't get cmi.completion_status: " + err)
                }
          
                // brb: determine if due date has passed for assignment
                if (Get_ARGA_Data("due_date_has_passed") == 1) {
                    this.DUE_DATE_HAS_PASSED = true;
                }
            }
        
            var focus_h1 = true;

            // only show this alert if there are questions on the page
            if (this.DUE_DATE_HAS_PASSED && !this.ACTIVITY_COMPLETED &&
                $('[data-type="question"]').length > 0) {

                $('.question_submit_button').each(function() {
                  var $this = $(this);
                  $this.remove();
                });
          
                // disable all questions
                $('[data-type="question"]').each(function() {
                  var $this = $(this);
                  $this.find('textarea').attr("disabled",true);
                });
                focus_h1 = false;
                Standard_Dialog.open('The due date for this assignment has now passed. You may watch the video but you will not be able to submit answers for a grade. Please contact your instructor for further information.', {title: 'Activity Past Due', from: $('#h1_header')});
            }
            else if (this.ACTIVITY_COMPLETED && $('[data-type="question"]').length > 0) {
                focus_h1 = false;
                Standard_Dialog.open('You have completed this activity. Please refer to the grade book for your final score.', {title: 'Activity Completed', from: $('#h1_header')});
            }
            else if (!this.ACTIVITY_COMPLETED && $('[data-type="question"]').length > 0) {
                // add instructions for screen reader
                $('#h1_header').after('<h2 class="visually-hidden save">Instructions</h2><p class="visually-hidden">Watch the video below and then answer the questions that follow.</p>');
                /*
                var $video = $('#outer_outer_outer_video');
                if ($video.length > 0) {
                    $video.before('<h2 class="visually-hidden save">Video</h2>');
                }
                else {
                    $('[data-type="mov"]').parent().before('<h2 class="visually-hidden save">Video</h2>');
                }
                */
            }

            var video_header_text = $('[data-block_type="h3_header"]').length > 0 ? "Videos" : "Video";
            $('[data-block_type="BX_v1"]').before('<h2 class="visually-hidden save">' + video_header_text + '</h2>');



	var link_handler = new LinkHandler();

    $('body').append('<div id="aria-speech" aria-live="assertive" class="visually-hidden"></div>');

    $('#manuscript').changeElementType('main');
    // remove empty <p> tags
    $('p').each(function() {
        var $this = $(this);
        var text = $this.html();
        if (text === "<br><br>") {
            $this.remove();
        }
    });
    // Get rid of play button image
    $('img[src$="play.jpg"]').each(function() {
        $(this).parent().remove();
    });
    // Get rid of hrule image
    $('img[src$="hrule.jpg"]').each(function() {
        $(this).parent().remove();
    });
    // Get rid of round button image
    $('img[src$="round.png"]').each(function() {
        $(this).parent().remove();
    });   

    // remove unnecessary h2/h3 headers (they are duplicates of h1 header)
    $('h2').each(function() {
        var $this = $(this);
        if (!($this.hasClass('save'))) {
            $this.remove();
        }
    });
    $('h3').each(function() {
        var $this = $(this);
        if (!($this.hasClass('essay_answer_header'))) {
            $this.remove();
        }
    });

    $('[data-block_type="h3_header"]').each(function() {
        var $this = $(this);
        $this.addClass('visually-hidden');
        $this.changeElementType('h3');
    });

    $('[data-block_type="subTitle"]').each(function() {
        var $this = $(this);
        $this.find('p').remove();
        $this.text('Discussion Questions');
        $this.changeElementType('h2');
    });

    $('[data-block_type="h4"]').remove();
    $('[data-block_type="trans"').children('p').attr('id','trans');

    // get rid of duplicate IDs (the iframe and its figure wrapper <div>
    // have the same ID)
    $('[data-type="box_inner"] > [data-type="figure"]').each(function() {
        var $this = $(this);
        var new_id = $this.attr('id') + "x";
        $this.attr('id', new_id).addClass('video_div');
    });

    // Make transcript/commentarty links accessible
    $('[data-block_type^="doc:"]').each(function() {
        var $this = $(this);
        var file_path = $this.attr('data-block_type').replace(/doc:/, "");
        var target = file_path.replace(/.*\/([^/]+)/,"$1")
            .replace(/\.html?/,"").toLowerCase();
        $this.attr("href",file_path).attr('target', target);
        var link_text = $this.text();
        if (link_text.match(/Transcript/i)) {
            link_text = link_text.replace(/Transcript/, "transcript");
            /*
            link_text = link_text.replace(/transcript/,
                "<nobr>transcript<img src='asset/round.png'/ aria-hidden='true' alt='(Opens in new window)'></nobr>");
            */
        }
        else {
            link_text = link_text.replace(/Commentary/, "commentary");
            /*
            link_text = link_text.replace(/commentary/,
                "<nobr>commentary<img src='asset/round.png'/ aria-hidden='true' alt='(Opens in new window)'></nobr>");
            */
        }
        link_text += '<span class="visually-hidden"> (Opens in new window)</span>';
        $this.html(link_text);
        $this.changeElementType("a");
    });

    $('[data-block_type="quesNo"]').each(function() {
        var $this = $(this);
        var text = $this.text();
        $this.html('<span class="visually-hidden">Question </span>' + text); 
        $this.changeElementType('h3');
    });

    // if there is no BX_v2 box wrapping the questions, then add it
    if ($('[data-block_type="BX_v2"]').length === 0) {
        $('[data-type="question"]').wrapAll('<div data-block_type="BX_v2" />').wrapAll('<div data-type="box_inner" />');
    }

    // if there are no question number headers, then add them
    /*
    if ($('h2[data-block_type="quesNo"]').length === 0) {
        $('[data-type="question"]').each(function() {
            var $this = $(this);
            var q_num = $this.attr('data-question_index');
            $this.before('<h2 data-block_type="quesNo"><span class="visually-hidden">Question </span>' + q_num + '.</h2>');
        });
    }
    */

    // get rid of labels added in manuscript-specific JS files
    var timer_count = 20;
    var timer = setInterval(function() {
        //if ($('label.hidecomment').length > 0) {
            $('label.hidecomment').remove(); 
        //}
        timer_count--;
        if (timer_count < 0) {
            clearInterval(timer);
        }
    }, 500);
    
    // Some of these videos have been intentionally removed and use an image to display that message. Set the alt text for this image and make sure it displays properly on the page.
    $('[src="asset/novideo.jpg"]').each(function() {
        var $img = $(this);
        var $parent = $img.parent();
        $parent.addClass('no_video');
        $img.attr('alt','The license for this video has expired and it has been intentionally removed by the publisher.');
    });
        
    // get rid of empty query_display span
    $('span[data-type="query_display"]').remove();

    // get rid of empty <p>
    $('p').each(function() {
        safe_log("[" + $(this).html() + "]");
        var $this = $(this);
        var html = $this.html();
        if (html === "<br>") {
            safe_log("REMOVED");
            $this.remove();
        }
    });

    $("#trans2").attr('id','trans1');
    $("#trans3").attr('id','trans1');
    $("#trans4").attr('id','trans1');
    $("#trans5").attr('id','trans1');
    $("#trans6").attr('id','trans1');
    $("#trans7").attr('id','trans1');
    $("#trans8").attr('id','trans1');
    $("#trans9").attr('id','trans1');
    $("#trans10").attr('id','trans1');
    $("#trans11").attr('id','trans1');
    $("#trans12").attr('id','trans1');

    if (focus_h1) {
        $('#h1_header').focus();
    }


    /*
	$('[data-block_type^="doc:"]').each(function() {
	    var $this = $(this);
	    var block_type = $this.attr('data-block_type');
	    var path = block_type.replace(/doc:/, "");
	    $this.attr('data-href', path).attr('data-target', '_pop');
	});
         var textLength=$("textarea").length;
         for(j=0;j<textLength;j++){
             document.getElementById("question_submit_button_"+(j+1)).addEventListener("click", displayDate);
         }
         */
    },

    aria_speech: function(mesg) {
        $('#aria-speech').text('');
        setTimeout(function(){
            $('#aria-speech').text(mesg); 
        }, 500);
    }
});
function displayDate(){
    var getHtml= $(".essay_question_evaulation_feedback").html();
    var getClass= $(".essay_question_evaulation_feedback").attr("class");
    var getId=this.id;
    var splitId=getId.split("question_submit_button_")[1];
    var setId="ariaText_"+parseInt(splitId-1);
    $(".tabIndexes").removeAttr("tabindex");
    var content='<a class="tabIndexes" role="alert" tabindex="0" id='+setId+'><div class='+getClass+'>'+getHtml+'</div></a>';
    $(content).insertAfter( $( "#query_answer_"+parseInt(splitId-1) ) );
    $("a#"+setId).next("div").remove();
}



player = new Player_subtype();


Essay_Query = Essay_Query.extend({

    query_text_html: function() {

        if (this.query_text != "" && this.md._hide_query_text != "true") {
            // replace newlines with <br />
            var qt = jQuery.trim(this.query_text).replace(/\n/g, "<br>")

            return "<label for='query_answer_" + this.query_index + "' class='query_text'><span class='visually-hidden'>Question " + this.parent_question.index + ":</span>" + qt + "</label>"
        } else {
            return "";
        }
    },

    getHTML: function(mode) {

        // start with the query text, if there
        var html = this.query_text_html();
        var val, disabled;

        if (!this.userHasAnswered() || mode == 'preview') {
            val = "";
            disabled = "";
        } 
        // otherwise we have an answer, so fill it in
        else {
            // make sure we convert double quotes to &#34; for placement in 'value="xxx"' attributes
            val = this.user_answer;

            // convert breaks to newlines
            val = val.replace(/<br *(\/)?>/g, "\n");

            // also disable the input if we're not in review_correct_incorrect mode

            if (mode != "review_correct_incorrect") {
                disabled = "disabled";
            }
        }
        
        if (!this.userHasAnswered()) {
            html += "<textarea id='query_answer_" + this.query_index + "' class='query_essay_ta' " + disabled + ">"
                + val + "</textarea>";
        }
        else {
            /*
            html += "<h3 class='essay_answer_header visually-hidden' id='essay_answer_" + this.query_index + "' class='visually-hidden'>Answer for question " + this.parent_question.index + "</h3>" +
                "<div class='essay_answer_text'><span class='visually-hidden'>Answer for question " + this.parent_question.index + ", </span>" + val + "</div>";
            */
           html += "<div class='essay_answer_text'><span class='visually-hidden'>Answer for question " + this.parent_question.index + ", </span>" + val + "</div>";
        }
            
        // if answer was just entered and grade is 100, also show the "provisional" message
        // (unless for this question it isn't provisional)

        var q_num = this.parent_question.index;

        if (this.answer_was_just_entered && this.grade == 100 && this.md.points_are_provisional == "true") {
            var feedback_id = "es_feedback_" + this.query_index;
            html += "<h4 class='visually-hidden' id='es_feedback_h4_" + this.query_index + "'>Question " + q_num + " Feedback</h4><div id='" + feedback_id + 
            "' class='essay_question_evaulation_feedback'>Your answer has been provisionally accepted. You'll get full credit for now, but your instructor may update your grade later after evaluating it.</div>";
        }

        /*
        setTimeout(function() {
            player.aria_speech("Question " + q_num + " feedback: Your answer has been provisionally accepted. You'll get full credit for now, but your instructor may update your grade later after evaluating it.");
        }, 500);
        */

        return html;
        
    }


});

var KEY_CODES = {
    ENTER: 13,
    TAB: 9,
    ESC: 27,
    SPACE: 32,
    LEFT: 37,
    RIGHT: 39
};

var Standard_Dialog = function() {
    var $manuscript = $('#manuscript');
    var $body = $('body');
    var $dialog, $content;
    var options = {};
  
    return {
      open: function(html, opt) {
        // Extend default options
        options = $.extend(true, (opt || {}), {
          width: 450,
          modal: true,
          draggable: false,
          resizable: false
        });
  
        // Set buttons
        if (options.buttons === 'none') {
          options.buttons = null;
        }
        else if (options.buttons === 'OK' || !options.buttons) {
          options.buttons = [ { text: 'OK', click: Standard_Dialog.close } ];
        }
  
        // Remove previous dialog
        $('#standard_dialog_div').dialog('close').remove();
  
        if (options.modal) {
          $body.css('overflow', 'hidden');
        }
  
        // Hide other content from reader for mobile devices
        $manuscript.attr('aria-hidden', 'true');
  
        $dialog = $('<div id="standard_dialog_div"></div>');
        $content = $('<div class="dialog-div">' + (html || '') + '</div>');
  
        $dialog.append($content);
        $dialog.dialog(options);
  
        // If we open toc we use as description only instruction in the top of dialog and not links
        var isMenu = $content.find('#toc_head').length;
        var labelledBy = isMenu ? 'toc_head' : 'standard_dialog_div';
  
        var $parentDialog = $dialog.parent().attr({
          'tabindex': '0',
          'role': 'dialog',
          'aria-labelledby': 'ui-dialog-title-standard_dialog_div ' + labelledBy
        });
  
        $parentDialog.find('#ui-dialog-title-standard_dialog_div').attr({
          'role': 'heading',
          'aria-level': '1'
        });
  
        // Remove close btn
        $('.ui-dialog-titlebar-close').remove();
  
        var $lastBtn = $parentDialog.find('button').last();
        var $firstBtn = $parentDialog.find('button').first();
  
        // Attach events
        $parentDialog.bind('keydown', function(e) {
          var code = e.keyCode || e.which;
  
          if (code === KEY_CODES.ESC) {
            if (typeof options.buttons[0].click === 'function') {
              options.buttons[0].click();
            }
            else {
              Standard_Dialog.close(true);
            }
          }
  
          if (e.target === this && e.shiftKey && code === KEY_CODES.TAB) {
            e.preventDefault();
            $lastBtn.focus();
          }
        });
        $lastBtn.bind('keydown', function(e) {
          var code = e.keyCode || e.which;
  
          if (!e.shiftKey && code === KEY_CODES.TAB) {
            $parentDialog.focus();
            e.preventDefault();
          }
        });
  
        /*
        if (runOn.mobile) {
          // For android we set focus on dialog in any cases
          $parentDialog.focus();
        }
        else if (isMenu) {
          // If it is menu put focus on first link
          $parentDialog.find('a').first().focus();
        }
        else {
        */
          // For other platform we set focus on first button
          setTimeout(function() {
            $firstBtn.focus();
          }, 100);
        //}
      },
  
      // for now alert is just like any other dialog; we could change that later.
      wait: function(html, opt) {
        options = opt || {};
        options.buttons = 'none';
        Standard_Dialog.open(html, options);
      },
  
      alert: function(html, opt) {
        Standard_Dialog.open(html, opt);
      },
  
      close: function() {

        // Show other content
        $('#manuscript').attr('aria-hidden', 'false');
  
        if ($dialog) {
          $dialog.dialog('close').remove();
        }
        else {
          $("#standard_dialog_div").remove();
        }
  
        if (options.from) {
          options.from.focus();
        }
  
        if (options.modal) {
          $body.css('overflow', 'auto');
        }
      }
    };
  }();